# AD210 Nachbau
# es waren einige Aenderungen erforderlich, weil der UART 
# nicht Byte-transparent ist
# Beispiele:
# Bytes > 127 werden in 2 Zeichen Unicode umgewandelt
# Byte 4 loest einen soft reset aus

# Befehle
# u: Kennung, Antwort: U
# a: ADC0 abfragen, Antwort: String(!) 0...1023
# b: ADC1 abfragen, Antwort: String(!) 0...1023
# c: ADC2 abfragen, Antwort: String(!) 0...1023
# e + 0....1023 : PWM an Pin2 
# c und e sollten nicht gemeinsam eingesetzt werden

# license: wtfpl
# http://www.wtfpl.net/txt/copying/

from microbit import *
uart.init(115200)
pin2.set_analog_period(10)

while (1):

    if (uart.any() != 0):
        char_command = uart.read(1)
        command = ord(char_command)

        # Kennung zuruecksenden
        # diese Variante funktioniert eigenartigerweise nicht:       
        # if char_command == "u":
        # daher war oben mit "ord" die Umrechnung in eine Zahl erforderlich
        # und es werden Zahlen abgefragt:

        if command == 117:
            uart.write("U")

         # Analogwert des Pin0 senden
        elif command == 97:
            value = pin0.read_analog()
            value_str = str(value)
            uart.write(value_str)

        # Analogwert des Pin1 senden
        elif command == 98:
            value = pin1.read_analog()
            value_str = str(value) 
            uart.write(value_str)

        # Analogwert des Pin2 senden
        elif command == 99:
            value = pin2.read_analog()
            value_str = str(value) 
            uart.write(value_str)

        # PWM an Pin2 ausgeben
        elif command == 101:
            mystring = uart.read()
            try:
                pwm = int(mystring) 
                if pwm > 1023:
                    pwm=1023
                pin2.write_analog(pwm)
            except:
                pass
